DEF VAR cFile          AS CHAR NO-UNDO.
DEF VAR sp-companycode AS CHAR NO-UNDO.
DEF VAR lOk            AS LOG  NO-UNDO.
DEF VAR cLocationList  AS CHAR NO-UNDO.
DEF VAR dtStart        AS DATE NO-UNDO.
DEF VAR cLocationStart AS CHAR NO-UNDO.
DEF VAR dtEnd          AS DATE NO-UNDO.
DEF VAR cLocationEnd   AS CHAR NO-UNDO.
DEF VAR dtBegin        AS DATE NO-UNDO.
DEF VAR iDays          AS INT  NO-UNDO.
DEF VAR cStatusStart   AS CHAR NO-UNDO.
DEF VAR cStatusEnd     AS CHAR NO-UNDO.
DEF VAR cContract      AS CHAR NO-UNDO.

sp-companycode = "ROW".
cLocationlist  = "rtmect,houdep,havdep".
dtBegin        = DATE("14/07/2008").
/*
cLocationList = 'BIOEWL' 
              + 'BZEWL' 
              + 'COEWL' 
              + 'DOLE HON' 
              + 'FXTEWL' 
              + 'GBEWL' 
              + 'GBGRA' 
              + 'GLWEWL' 
              + 'GUAEWL' 
              + 'HALEWL' 
              + 'IEEWL' 
              + 'KINEWL' 
              + 'LAGEWL' 
              + 'MANEWL' 
              + 'MOBEWL' 
              + 'MONEWL' 
              + 'MTL' 
              + 'MURPHY' 
              + 'NLEWL' 
              + 'ORJEWL' 
              + 'PBLEWL' 
              + 'PBMEWL' 
              + 'PCREWL' 
              + 'PHIEWL' 
              + 'POSEWL' 
              + 'STCEWL' 
              + 'THAEWL' 
              + 'TOREWL' 
              + 'UCT' 
              + 'UNIPORT' 
              + 'UNKNOWN' 
              + 'VEEWL' 
              + 'WILEWL'
              .*/
cFile = "c:\tmp\fyffes-ewl.txt".
OUTPUT TO VALUE(cFile).
PUT UNFORMATTED "Prefix;"
                "Number;"
                "Lease contract;"
                "In location;"
                "Status;"
                "Date;"
                "Out location;"
                "Status;"
                "Date;"
                "Days"                SKIP .

FOR EACH ec-container NO-LOCK WHERE
         ec-container.companycode     = sp-companycode:
  FIND LAST ec-container_contract WHERE
            ec-container_contract.companycode     = sp-companycode
        AND ec-container_contract.containerprefix = ec-container.containerprefix
        AND ec-container_contract.containernr     = ec-container.containernr 
            NO-LOCK NO-ERROR.
  IF AVAIL ec-container_contract 
  THEN cContract = ec-container_contract.contractcode.
  ELSE cContract = "".
  FIND LAST ec-container_history WHERE
            ec-container_history.companycode     = sp-companycode
        AND ec-container_history.containerprefix = ec-container.containerprefix
        AND ec-container_history.containernr     = ec-container.containernr 
        AND ec-container_history.dt_move        <= dtBegin
            USE-INDEX dt_move NO-LOCK NO-ERROR.
  IF AVAIL ec-container_history 
  THEN DO:
    lOk = TRUE.
    blok:
    DO WHILE lOk:
      IF   LOOKUP(ec-container_history.locationcode,cLocationlist) > 0 
      THEN DO:
        IF dtStart = ?
         AND ec-container_history.statuscode <> "OFH"
        THEN DO:
          ASSIGN dtStart        = ec-container_history.dt_move
                 cLocationStart = ec-container_history.locationcode
                 cStatusStart   = ec-container_history.statuscode.
        END.
      END.
      ELSE DO:
        IF dtStart <> ?
        THEN DO:
          ASSIGN dtEnd        = ec-container_history.dt_move
                 cLocationEnd = ec-container_history.locationcode
                 cStatusEnd   = ec-container_history.statuscode.
        END.
      END.
    
      IF dtStart <> ? AND dtEnd <> ? 
      THEN DO:
        IF dtStart < dtBegin 
        THEN iDays = dtEnd - dtBegin.
        ELSE iDays = dtEnd - dtStart.
        PUT UNFORMATTED ec-container.containerprefix ";"
                        STRING(ec-container.containernr,"XXXXXX/X")  ";"
                        cContract                    ";" 
                        cLocationStart               ";"
                        cStatusStart                 ";"
                        dtStart                      ";"
                        cLocationEnd                 ";"
                        cStatusEnd                   ";"
                        dtEnd                        ";"
                        iDays                        SKIP .
        ASSIGN dtStart         = ?
               cLocationStart  = ""
               dtEnd           = ?
               cLocationEnd    = ""
               cStatusStart    = ""
               cStatusEnd      = "".
      END.
      
      FIND NEXT ec-container_history WHERE
                ec-container_history.companycode     = sp-companycode
            AND ec-container_history.containerprefix = ec-container.containerprefix
            AND ec-container_history.containernr     = ec-container.containernr 
                USE-INDEX dt_move  NO-LOCK NO-ERROR.
      IF NOT AVAIL ec-container_history 
      THEN LEAVE blok.
    END.
  END.
  IF dtStart <> ?
  THEN DO:
    IF dtStart < dtBegin 
    THEN iDays = TODAY - dtBegin.
    ELSE iDays = TODAY - dtStart.
    PUT UNFORMATTED ec-container.containerprefix ";"
                    STRING(ec-container.containernr,"XXXXXX/X") ";"
                    cContract                    ";" 
                    cLocationStart               ";"
                    cStatusStart                 ";"
                    dtStart                      ";"
                    ""                           ";"
                    ""                           ";"
                    ""                           ";"
                    iDays                        SKIP .
    ASSIGN dtStart         = ?
           cLocationStart  = ""
           dtEnd           = ?
           cLocationEnd    = ""
           cStatusStart    = ""
           cStatusEnd      = "".
  END.
END.

OUTPUT CLOSE.
